#### Create a standard postgres container

```commandline
docker pull postgres

docker run --detach \
    --name postgres-local \
    --env POSTGRES_USER=postgres \
    --env POSTGRES_PASSWORD=mysecretpassword \
    --env POSTGRES_DB=postgres \
    --env PGDATA=/var/lib/postgresql/data/pgdata \
	--volume /var/lib/postgres-local/generic:/var/lib/postgresql/data \
    --publish 5432:5432 \
	postgres
```

#### Build a docker image for pgvector postgres database
- Clone and build an image from the git repository
```git clone --branch v0.5.1 https://github.com/pgvector/pgvector.git
cd pgvector/
docker build --build-arg PG_MAJOR=15 -t tangibleai/pgvector:latest .
```
- Content of the Dockerfile
```yaml
ARG PG_MAJOR=15
FROM postgres:$PG_MAJOR
ARG PG_MAJOR

COPY . /tmp/pgvector

RUN apt-get update && \
apt-mark hold locales && \
apt-get install -y --no-install-recommends build-essential postgresql-server-dev-$PG_MAJOR && \
cd /tmp/pgvector && \
make clean && \
make OPTFLAGS="" && \
make install && \
mkdir /usr/share/doc/pgvector && \
cp LICENSE README.md /usr/share/doc/pgvector && \
rm -r /tmp/pgvector && \
apt-get remove -y build-essential postgresql-server-dev-$PG_MAJOR && \
apt-get autoremove -y && \
apt-mark unhold locales && \
rm -rf /var/lib/apt/lists/*
```

#### Create a pgvector container with postgres

```commandline
docker run --detach \
    --name postgres-local \
    --env POSTGRES_USER=postgres \
    --env POSTGRES_PASSWORD=mysecretpassword \
    --env POSTGRES_DB=postgres \
    --env PGDATA=/var/lib/postgresql/data/pgdata \
    --volume /var/lib/postgres-local/pgvector:/var/lib/postgresql/data \
    --publish 5432:5432 \
    tangibleai/pgvector:latest
```

#### Create extension
- Enable the extension (do this once in each database where you want to use it, run as query command)
```text
CREATE EXTENSION vector;
```

#### Create pgvector in template1 to run tests properly
- Connect to the `template1` database and run the command below.
```text
CREATE EXTENSION IF NOT EXISTS vector;
```

#### Adding an extension with migrations
- Create an empty migration `python manage.py makemigrations <app_name> --empty`
- Update the migration as below.
- This should be a dependency for the initial migration. (You can create vector migration first and initial after. Add vector migration as a dependency to the initial migration.)

```python
# Generated by Django 4.2.11 on 2024-06-07 09:01
from django.db import migrations


class Migration(migrations.Migration):
    dependencies = [
        ("api", "0001_initial"),
    ]

    operations = [
        migrations.RunSQL(
            sql="CREATE EXTENSION IF NOT EXISTS vector;",
            reverse_sql="DROP EXTENSION IF EXISTS vector;"
        ),
    ]
```

#### Example initial migration

```python
from django.db import migrations
from django.conf import settings


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("api", "0001_create_vector"),
    ]
```
